import java.util.*;

public class Check
{
	public static final int MAXP = 10;

	public static void printError(int line, String msg)
	{
		System.out.println("ERROR Line " + line + ": " + msg);
		System.exit(-1);
	}

	public static boolean repeated(String [] a, int n)
	{
		for(int i=0; i<n; i++)
			if (a[i].equals(a[n]))
				return true;
		return false;
	}

	public static void main(String [] args)
	{
		Scanner in = new Scanner(System.in);
		int n, nLines = 1;
		String line;
		String [] names = new String[MAXP];

		n = in.nextInt();
		if (n < 5 || n > MAXP)
			printError(1, "n value out of range: " + n);
		line = in.nextLine();
		line = in.nextLine();
		StringTokenizer st = new StringTokenizer(line);
		if (st.countTokens() != n) 
			printError(2, "incorrect number of names");
		for(int i=0; i<n; i++) {
			names[i] = st.nextToken();
			if (repeated(names, i))
				printError(2, "repeated name: " + names[i]);
		}
		line = in.next();
		for(int i=0; i<line.length(); i++) {
			char ch = line.charAt(i);
			if (ch != 'W' && ch != 'B')
				printError(3, "Illegal character in points string");
		}
		if (in.hasNext())
			printError(4, "extraneous data at end of file");
System.exit(42);
	}
}

